class CMargin{
public:
	double pick, axis, faceOverlap, move, adjust, adjustAngle;
	CMargin(){
		pick = 0.01;
		axis = 0.01;
		faceOverlap = 0.1;
		move = 0.1;
		adjust = 0.5;
		adjustAngle = 5.0;
	}
} Margin;

enum VertexLabel{ NoPickedCandidate, PickedCandidate, MoveCandidate, OnAxis, FixVertex, MoveVertex };

class CVertex{
public:
	int            birthStage;
	ogVector       position;
	ogVector2      texcoord;
	VertexLabel    label;
	class CVertex *pre;
	class CVertex *post;

	CVertex( ogVector &position, ogVector2 &texcoord, int birthStage = 0 ){ this->birthStage = birthStage; this->position = position; this->texcoord = texcoord; pre = post = NULL; }
	void labelNeighbors( ogVector &position ){ label = position.distance( this->position ) < Margin.pick ? PickedCandidate : NoPickedCandidate; }
	VertexLabel labelRegion( ogPlane &boundary );
	CVertex( int birthStage, CVertex &preVertex, ogLine &axis, double angle );
};

VertexLabel CVertex::labelRegion( ogPlane &boundary ){
	ogVector v = position - boundary.passage;
	double d = boundary.normal * v;
	if( fabs( d ) < Margin.axis ) return label = OnAxis;
	else if( d < 0 )              return label = MoveCandidate;
	else                          return label = FixVertex;
}

CVertex::CVertex( int birthStage, CVertex &preVertex, ogLine &axis, double angle ){
	this->birthStage = birthStage;
	pre = &preVertex;
	post = NULL;
	position.rotate( preVertex.position, axis, angle );
	texcoord = preVertex.texcoord;
}
